Program Makescales_shift
! Finds aa%mis for multiple scales of data, saves as a file
! mask - mask of missing data
! a - size of PEF
! center - position of leading 1 in PEF
! gap - size of zeroes after 1
! sc - scales to use, based on first dimension.  Must include original scale

use sep
use coarsen_shift_norm
!use coarsen
use dottest

implicit none

! declarations

integer                                   :: dim, stat, tt(1000), nsc, is, ih, count, id
integer, dimension (:),   allocatable     :: nn, sc, mark, nmn, tmn, sh, ssh, tsh
real,    dimension (:),   pointer         :: k0, coo, cdd
real,    dimension (:,:), pointer         :: co, cd
real,    dimension (:),   allocatable     :: oo, dd, data, output, tempout, mco, mcd
integer, dimension (:,:), allocatable     :: mn
real,    dimension (2)                    :: dot1, dot2
integer, external                         :: getch

 ! read from history, param

  call sep_init(SOURCE)
  dim = sep_dimension()

  allocate(nn(dim),oo(dim),dd(dim),coo(dim),cdd(dim), tmn(dim), tsh(dim))

  call from_history ("n",nn)
  call from_history ("o",oo)
  call from_history ("d",dd)

! Read scale parameters
  nsc = getch("sc","d",tt)
  allocate( sc(nsc), mn(nsc,dim), co(nsc,dim), cd(nsc,dim), nmn(nsc*dim), mco(nsc*dim), mcd(nsc*dim), sh(nsc), ssh(nsc) )
  sc(1:nsc)=tt(1:nsc)
  call from_param ("sc", sc)
!write(0,*)"Parameters sc",sc,"nsc",nsc,"nn",nn
  sh(1)=0
  do is=1,nsc
     mn(is,:)=int(sc(is)*nn(:)/nn(1))
     ! Calculate number of shifts for this scale
     sh(is)=int(mn(1,2)/mn(is,2))-1
     ssh(is)= (sh(is)+1)**(dim-1)
  end do
  allocate(mark(sum(ssh)+1))
  mark=1
  count=1
  do is=1,nsc
     do ih=1,ssh(is)
        mark(count+1) = mark(count) + product(mn(is,:))
        count=count+1
     end do
  end do

  allocate( data(product(nn)), k0(product(nn)), output(mark(count)-1))
  output=0

  call sep_read( data )
  k0 = 1.
  if (exist_file ("maskin"))  call sep_read( k0, "maskin")

  write(0,*)"mark", mark,"sh",sh
  count=1
  do is=1,nsc
     do ih=0,ssh(is)-1
                                            write(0,*)"Makescales scale #",is
        allocate(tempout(product(mn(is,:))))
                                            write(0,*)"break1"
        tempout=0.
                                            write(0,*)"break2"
        tmn=mn(is,:)
                                            write(0,*)"break3"
        tsh(1)=0
        do id=2,dim
                                            write(0,*)"break4,ih,dim,id",ih,dim,id
           tsh(id)=mod(int(ih/(2**(dim-id))),2)
        end do
                                            write(0,*)"break5"
        call coarsen_shift_norm_init(oo,dd,nn,coo,cdd,tmn,tsh*dd,k0)
                                            write(0,*)"Makescales init nn,mn",nn, tmn,"tsh",tsh
        co(is,:)=coo; cd(is,:)=cdd
!                                            write(0,*)"Makescales prelop size tempout? ",size(output(mark(is):mark(is+1)-1)),size(tempout)
!                                            write(0,*)"mix max size data",minval(data),maxval(data),size(data)
        stat = coarsen_shift_norm_lop(.true., .false., tempout, data)
!                                            write(0,*)"Makescales endloop tempout minmaxsize",minval(tempout),maxval(tempout),size(tempout)
!                                            write(0,*)"Makescales postlop",size(tempout),size(output),mark(is),mark(is+1)-1
        output(mark(count):mark(count+1)-1) = tempout
        count=count+1
        deallocate(tempout)
!                                            write(0,*)"Makescales deallocate"
        call coarsen_shift_norm_close()
     end do
  end do

  write(0,*)"mix max size output",minval(output),maxval(output),size(output)
!  write(0,*)"co cd", co, cd
!  write(0,*)"oo dd", co, cd

  call to_history("n1", mark(count)-1)
  call to_history("n2", 1)
  call to_history("n3", 1)
  call to_history("n4", 1)
  call to_history("nshifts",ssh)
  call to_history("m",nn)
  call to_history("nsc",nsc)
  nmn = reshape(mn,(/nsc*dim/))
  call to_history("nbank", nmn)
  call to_history("mark",mark)
  call to_history("dim",dim)
  call to_history("ndp",count)
  call sep_write (output)
  call sep_close ()
  call exit (0)
  deallocate(nn,oo,dd,sc,co,cd,mco,mcd,output,data,k0,mn)
end Program
