Program Rescale
! Finds aa%mis for multiple scales of data, saves as a file
! mask - mask of missing data
! a - size of PEF
! center - position of leading 1 in PEF
! gap - size of zeroes after 1
! sc - scales to use, based on first dimension.  Must include original scale

use sep
use coarsen_shift_norm
!use coarsen
use dottest

implicit none

! declarations

integer                                   :: dim, stat
integer, dimension (:), allocatable       :: nn, sc
real,    dimension (:), allocatable       :: oo, dd, sh, data, output
real,    dimension (:), pointer           :: co, cd, k0
real,    dimension (2)                    :: dot1, dot2

 ! read from history, param
 !                                                                          write(0,*)"BoundB 1"
  call sep_init(SOURCE)
  dim = sep_dimension()

  allocate(nn(dim),sc(dim),oo(dim),dd(dim),co(dim),cd(dim),sh(dim))

  call from_history ("n",nn)
  call from_history ("o",oo)
  call from_history ("d",dd)

  call from_param ("sc",sc)
  call from_param ("sh",sh)
  allocate( data(product(nn)), k0(product(nn)), output(product(sc)))

  call sep_read( data )
  k0 = 1.
  if (exist_file ("maskin"))  call sep_read( k0, "maskin")

  write(0,*)"mix max size data",minval(data),maxval(data),size(data)

  call coarsen_shift_norm_init(oo,dd,nn,co,cd,sc,sh,k0)

 ! call dot_test(coarsen_shift_norm_lop,product(sc),product(nn),dot1,dot2)

  stat = coarsen_shift_norm_lop(.true., .false., output, data)

  write(0,*)"mix max size output",minval(output),maxval(output),size(output)
!  write(0,*)"co cd", co, cd
!  write(0,*)"oo dd", co, cd

  call to_history("n",sc)
  call to_history("o",co)
  call to_history("d",cd)
  call to_history("n1",sc(1))
  call to_history("n2",sc(2))
  call to_history("n3",sc(3))
  call to_history("o1",co(1))
  call to_history("o2",co(2))
  call to_history("o3",co(3))
  call to_history("d1",cd(1))
  call to_history("d2",cd(2))
  call to_history("d3",cd(3))
  call sep_write (output)
  call sep_close ()
  call exit (0)
  deallocate(nn,oo,dd,sc,co,cd,sh,output,data,k0)
end Program
