module lint3 
! (Bi)Linear interpolation in 3-D
  use adj_mod
  implicit none
  integer, pointer :: n(:)
  real, pointer    :: o(:), d(:), f(:), g(:), xy(:,:) 
  integer          :: nd, ndim
  contains
  subroutine lint3_init ( n_in,o_in,d_in,xy_in )
    integer, dimension (:), pointer   :: n_in 
    real, dimension (:), pointer      :: o_in 
    real, dimension (:), pointer      :: d_in 
    real ,   dimension (:,:), pointer :: xy_in 
    integer                           :: idata, idim
    allocate(n(3),o(3),d(3),f(3),g(3))
    n => n_in 
    o => o_in 
    d => d_in 
    xy => xy_in
    nd = size(xy,1)
!    write(0,*)"init",nd,n,o,d
  end subroutine
  function lint3_lop ( adj, add, mm, dd) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: mm,dd 
    call adjnull (adj,add,mm,dd )
!write(0,*)"more sizes",size(mm),size(dd)
    call lint3_lop2(adj,mm,dd )
    stat=0
  end function 
  subroutine lint3_lop2(adj,mm,dd)
    logical,intent(in) :: adj  
    real, dimension (n(1),n(2),n(3))  :: mm 
    real, dimension (:)  :: dd
    integer :: id, im, ix, iy, iz, i(3)
    real    :: fract
!write(0,*)'lintn_lop1 size mm dd',size(mm),size(dd),n
    do id= 1,nd
      f = (xy(id,:)-o)/d
      i=f
      ix= 1+i(1)
      iy= 1+i(2)
      iz= 1+i(3)
!write(0,*)"ixiyizn1n2n3",ix,iy,iz,n
      if ( 1>ix .or. ix>=n(1)) then
        cycle
      end if
      if ( 1>iy .or. iy>=n(2)) then
        cycle
      end if
      if ( 1>iz .or. iz>=n(3)) then
        cycle
      end if
      f=f-i
      g= 1.-f
!   write(0,*)"lint3 f g",f,g
      if ( adj) then
        mm(ix  ,iy  ,iz  ) =                        mm(ix  ,iy  ,iz  ) + g(1)*g(2)*g(3)*dd(id)
        mm(ix+1,iy  ,iz  ) =                        mm(ix+1,iy  ,iz  ) + f(1)*g(2)*g(3)*dd(id)
        mm(ix  ,iy+1,iz  ) =                        mm(ix  ,iy+1,iz  ) + g(1)*f(2)*g(3)*dd(id)
        mm(ix+1,iy+1,iz  ) =                        mm(ix+1,iy+1,iz  ) + f(1)*f(2)*g(3)*dd(id)
        mm(ix  ,iy  ,iz+1) =                        mm(ix  ,iy  ,iz+1) + g(1)*g(2)*f(3)*dd(id)
        mm(ix+1,iy  ,iz+1) =                        mm(ix+1,iy  ,iz+1) + f(1)*g(2)*f(3)*dd(id)
        mm(ix  ,iy+1,iz+1) =                        mm(ix  ,iy+1,iz+1) + g(1)*f(2)*f(3)*dd(id)
        mm(ix+1,iy+1,iz+1) =                        mm(ix+1,iy+1,iz+1) + f(1)*f(2)*f(3)*dd(id)

      else
        dd(id) = dd(id) + g(1)*g(2)*g(3)*mm(ix  ,iy  ,iz  ) + f(1)*g(2)*g(3)*mm(ix+1,iy  ,iz  ) &
          &             + g(1)*f(2)*g(3)*mm(ix  ,iy+1,iz  ) + f(1)*f(2)*g(3)*mm(ix+1,iy+1,iz  ) &
          &             + g(1)*g(2)*f(3)*mm(ix  ,iy  ,iz+1) + f(1)*g(2)*f(3)*mm(ix+1,iy  ,iz+1) &
          &             + g(1)*f(2)*f(3)*mm(ix  ,iy+1,iz+1) + f(1)*f(2)*f(3)*mm(ix+1,iy+1,iz+1)
      end if
    end do
!   write(0,*)'lintn_lop8 mm dd', size(mm),minval(mm),maxval(mm),minval(dd),maxval(dd),size(dd)
  end subroutine 
  subroutine lint3_close()
  end subroutine 
end module 
